#line 979 "nw/geoma.nw"
    #include <iostream>
    #include <stdexcept>
    #include <complex>
    #include "geoma.h"
    #include "geomaData.h"

    
#line 595 "nw/geoma.nw"
int
main( void )
{
    nklein::GeometricAlgebra< int, 2, 1 > a;
    nklein::GeometricAlgebra< int, 2, 1 > b;
    nklein::GeometricAlgebra< int, 2, 1 > c(false);
    nklein::GeometricAlgebra< int, 3 > d;
    nklein::GeometricAlgebra< double, 3 > e;
    nklein::GeometricAlgebra< complex< double >, 3 > f;

    a[0] = 1;
    a[1] = 1;
    a[3] = 1;
    a[7] = 1;

    b[1] = 1;
    b[2] = 1;
    b[4] = 1;

    c = a;
    cout << "a = " <<
	
#line 658 "nw/geoma.nw"
	            c[0]
	<< " + " << c[1] << "e_1"
	<< " + " << c[2] << "e_2"
	<< " + " << c[4] << "e_3"
	<< " + " << c[3] << "e_{12}"
	<< " + " << c[5] << "e_{13}"
	<< " + " << c[6] << "e_{23}"
	<< " + " << c[7] << "e_{123}"
	<< endl
#line 616 "nw/geoma.nw"
                      ;

    c = b;
    cout << "b = " <<
	
#line 658 "nw/geoma.nw"
	            c[0]
	<< " + " << c[1] << "e_1"
	<< " + " << c[2] << "e_2"
	<< " + " << c[4] << "e_3"
	<< " + " << c[3] << "e_{12}"
	<< " + " << c[5] << "e_{13}"
	<< " + " << c[6] << "e_{23}"
	<< " + " << c[7] << "e_{123}"
	<< endl
#line 620 "nw/geoma.nw"
                      ;

    c = 2 * a - b;
    cout << "2*a - b = " <<
	
#line 658 "nw/geoma.nw"
	            c[0]
	<< " + " << c[1] << "e_1"
	<< " + " << c[2] << "e_2"
	<< " + " << c[4] << "e_3"
	<< " + " << c[3] << "e_{12}"
	<< " + " << c[5] << "e_{13}"
	<< " + " << c[6] << "e_{23}"
	<< " + " << c[7] << "e_{123}"
	<< endl
#line 624 "nw/geoma.nw"
                      ;

    c = a.GradeInvolution();
    cout << "\\hat{a} = " <<
	
#line 658 "nw/geoma.nw"
	            c[0]
	<< " + " << c[1] << "e_1"
	<< " + " << c[2] << "e_2"
	<< " + " << c[4] << "e_3"
	<< " + " << c[3] << "e_{12}"
	<< " + " << c[5] << "e_{13}"
	<< " + " << c[6] << "e_{23}"
	<< " + " << c[7] << "e_{123}"
	<< endl
#line 628 "nw/geoma.nw"
                      ;

    c = a.Reversion();
    cout << "\\tilde{a} = " <<
	
#line 658 "nw/geoma.nw"
	            c[0]
	<< " + " << c[1] << "e_1"
	<< " + " << c[2] << "e_2"
	<< " + " << c[4] << "e_3"
	<< " + " << c[3] << "e_{12}"
	<< " + " << c[5] << "e_{13}"
	<< " + " << c[6] << "e_{23}"
	<< " + " << c[7] << "e_{123}"
	<< endl
#line 632 "nw/geoma.nw"
                      ;

    c = a.Conjugation();
    cout << "\\bar{a} = " <<
	
#line 658 "nw/geoma.nw"
	            c[0]
	<< " + " << c[1] << "e_1"
	<< " + " << c[2] << "e_2"
	<< " + " << c[4] << "e_3"
	<< " + " << c[3] << "e_{12}"
	<< " + " << c[5] << "e_{13}"
	<< " + " << c[6] << "e_{23}"
	<< " + " << c[7] << "e_{123}"
	<< endl
#line 636 "nw/geoma.nw"
                      ;

    c = b*b;
    cout << "b*b = " <<
	
#line 658 "nw/geoma.nw"
	            c[0]
	<< " + " << c[1] << "e_1"
	<< " + " << c[2] << "e_2"
	<< " + " << c[4] << "e_3"
	<< " + " << c[3] << "e_{12}"
	<< " + " << c[5] << "e_{13}"
	<< " + " << c[6] << "e_{23}"
	<< " + " << c[7] << "e_{123}"
	<< endl
#line 640 "nw/geoma.nw"
                      ;

    c = a*b;
    cout << "a*b = " <<
	
#line 658 "nw/geoma.nw"
	            c[0]
	<< " + " << c[1] << "e_1"
	<< " + " << c[2] << "e_2"
	<< " + " << c[4] << "e_3"
	<< " + " << c[3] << "e_{12}"
	<< " + " << c[5] << "e_{13}"
	<< " + " << c[6] << "e_{23}"
	<< " + " << c[7] << "e_{123}"
	<< endl
#line 644 "nw/geoma.nw"
                      ;

    c = b*a;
    cout << "b*a = " <<
	
#line 658 "nw/geoma.nw"
	            c[0]
	<< " + " << c[1] << "e_1"
	<< " + " << c[2] << "e_2"
	<< " + " << c[4] << "e_3"
	<< " + " << c[3] << "e_{12}"
	<< " + " << c[5] << "e_{13}"
	<< " + " << c[6] << "e_{23}"
	<< " + " << c[7] << "e_{123}"
	<< endl
#line 648 "nw/geoma.nw"
                      ;

    return 0;
}
